SystemOrganization addCategory: #KoCizen!
SystemOrganization addCategory: #'KoCizen-Tests'!

CZPersonalGenerator subclass: #KZBibCollectionBuilder
	instanceVariableNames: 'dispatchTag outbibset bibset originalBibset author2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen'!

!KZBibCollectionBuilder commentStamp: 'sd 1/7/2012 21:53' prior: 0!
Generate collection of bibitems based on tags.!

!KZBibCollectionBuilder class methodsFor: 'examples' stamp: 'sd 1/8/2012 15:20'!
forStef
	"self forStef"
	
	^ self new 
		author: '*Ducasse*';
		loadBib: 'rmod.bib'.
		
		! !

!KZBibCollectionBuilder methodsFor: 'accessing' stamp: 'sd 1/8/2012 09:01'!
author
	"copy from above for now because I hate CZDocument and I do not like the superclass too"
	
	^ author ifNil: [ author := '*Ducasse*']! !

!KZBibCollectionBuilder methodsFor: 'accessing' stamp: 'sd 1/8/2012 13:47'!
author: aString
	"copy from above for now because I hate CZDocument and I do not like the superclass too"
	
	 author := aString! !

!KZBibCollectionBuilder methodsFor: 'operation' stamp: 'StephaneDucasse 1/18/2012 21:35'!
collectionBasedOnKozenTag: aTag

	^ KZBibCollection new elements: (self filterKozenTag: aTag); yourself
	

! !

!KZBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 13:47'!
filter: aQuery
	
	^ (bibset entries select: [ :each | aQuery value: each])! !

!KZBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 14:27'!
filterKozenTag: aTag

	^ self filter:  (self queryForKozenTag: aTag).! !

!KZBibCollectionBuilder methodsFor: 'initialize' stamp: 'sd 1/8/2012 13:52'!
initializeBibSetFromPath: inputFile
	"self new createBibSetFromPath: 'rmod.bib'"
	
	bibset := originalBibset := CZFileLoader bibFromFileNamed: inputFile.! !

!KZBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 13:51'!
inputFileName:  inputFileString

	inputFileName := inputFileString! !

!KZBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 13:53'!
loadBib: aString

	self initializeBibSetFromPath: aString.
	self prepareForAuthor.
	! !

!KZBibCollectionBuilder methodsFor: 'accessing' stamp: 'sd 1/8/2012 14:08'!
originalBibset 

	^ originalBibset ! !

!KZBibCollectionBuilder methodsFor: 'private' stamp: 'sd 1/11/2012 10:28'!
prepareForAuthor
	
	bibset entries: (originalBibset entries select: self withAuthor).
	bibset entries: (bibset entries reject:  (CZFieldQuery 
												named: #keywords 
												checks: [ :value | '*insubmission*' match: value ])).
	! !

!KZBibCollectionBuilder methodsFor: 'query' stamp: 'sd 1/8/2012 14:22'!
queryForKozenTag: aTag

	^ CZFieldQuery named: #keywords checks: [ :value | aTag match: value ]! !

!KZBibCollectionBuilder methodsFor: 'query' stamp: 'sd 1/8/2012 09:00'!
withAuthor
	^ CZFieldQuery named: #author checks: [ :value | self author match: value ]! !

CZHtmlOutputer subclass: #KZBibHTMLOutputer
	instanceVariableNames: 'fieldOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen'!

!KZBibHTMLOutputer commentStamp: 'StephaneDucasse 1/18/2012 21:35' prior: 0!
A specific Citezen outputer for HTML. In the future we should completely rewrite part of Citezen and we may not need this class anymore.!

!KZBibHTMLOutputer methodsFor: 'accessing' stamp: 'sd 1/8/2012 20:46'!
fieldOrder
	^ fieldOrder! !

!KZBibHTMLOutputer methodsFor: 'accessing' stamp: 'sd 1/8/2012 20:46'!
fieldOrder: anObject
	fieldOrder := anObject! !

!KZBibHTMLOutputer methodsFor: 'initialize' stamp: 'sd 1/8/2012 20:45'!
initialize

	super initialize.
	fieldOrder := #(#author 
			  #title 
			  #journal 
			  #booktitle 
			  #volume 
			  #pages 
			  #publisher  
			  #year 
			  #impactfactor 
			  #rate 
			  #url 
			  #doi)! !

!KZBibHTMLOutputer methodsFor: 'visit' stamp: 'sd 1/8/2012 20:54'!
visitEntry: anEntry
	
	| fields |
	fields := anEntry fieldSortedFollowingKeys: fieldOrder. 
	outputStream 
		nextPutAll: '<li>'.
	fields
		 do: [ :each | each acceptVisitor: self]
		 separatedBy: [outputStream nextPutAll: ', '].
	outputStream nextPut: $. .
	outputStream 
		nextPutAll: '</li>'.! !

!CZDisplayPattern methodsFor: '*kocizen' stamp: 'sd 1/8/2012 18:51'!
filteredEntry

	CZEntry new
		fields! !

!CZDisplayPattern methodsFor: '*kocizen' stamp: 'sd 1/8/2012 18:53'!
filteredEntry: anEntry
	
	| cpy |
	cpy := anEntry copy.
	anEntry
	 
		! !

TestCase subclass: #ARBibCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen-Tests'!

KZList subclass: #KZBibCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen'!

!KZBibCollection commentStamp: 'sd 1/8/2012 17:21' prior: 0!
I'm a wrapper so that I can be put in a site structure but holding items of citezen.
during my visit the visitor can decide to invoke a citezen exporter. 

Not clear at the design level yet.!

!KZBibCollection methodsFor: 'as yet unclassified' stamp: 'sd 1/8/2012 17:22'!
accept: aVisitor

	aVisitor visitBibItemCollection: self! !

!KZBibCollection methodsFor: 'as yet unclassified' stamp: 'sd 1/8/2012 18:19'!
elements: aCol

	elements := aCol! !
